// RIEN A MODIFIER //

#ifndef MY_TIMER_H
#define MY_TIMER_H

/*
Driver pour Timer 1  4 du STM32F103RB

*/

#include "stm32f103xb.h" 

/**
	* @brief  Active l'horloge et rgle l'ARR et le PSC du timer vis
  * @note   Fonction  lancer avant toute autre. Le timer n'est pas encore lanc (voir MyTimerStart)
	* @param  TIM_TypeDef Timer : indique le timer  utiliser par le chronomtre, TIM1, TIM2, TIM3 ou TIM4
	* 				int Arr   : valeur  placer dans ARR
	*					int Psc   : valeur  placer dans PSC
  * @retval None
  */
void MyTimer_Conf(TIM_TypeDef * Timer,int Arr, int Psc);


/**
	* @brief  Dmarre le timer considr
  * @note   
	* @param  TIM_TypeDef Timer : indique le timer  utiliser par le chronomtre, TIM1, TIM2, TIM3 ou TIM4
  * @retval None
  */
void MyTimer_Start(TIM_TypeDef * Timer);


/**
	* @brief  Arrt le timer considr
  * @note   
	* @param  TIM_TypeDef Timer : indique le timer  utiliser par le chronomtre, TIM1, TIM2, TIM3 ou TIM4
  * @retval None
  */
void MyTimer_Stop(TIM_TypeDef * Timer);


/**
	* @brief  Configure le Timer considr en interruption sur dbordement.
  * @note   A ce stade, les interruptions ne sont pas valids (voir  MyTimer_IT_Enable )
	* @param  TIM_TypeDef Timer : indique le timer  utiliser par le chronomtre, TIM1, TIM2, TIM3 ou TIM4
	* 				void (*IT_function) (void) : nom (adresse) de la fonction  lancer sur interruption
	*         int Prio : priorit associe  l'interruption
  * @retval None
  */
void MyTimer_IT_Conf(TIM_TypeDef * Timer, void (*IT_function) (void),int Prio);


/**
	* @brief  Autorise les interruptions
  * @note   
	* @param  TIM_TypeDef Timer : indique le timer  utiliser par le chronomtre, TIM1, TIM2, TIM3 ou TIM4
  * @retval None
  */
void MyTimer_IT_Enable(TIM_TypeDef * Timer);	


/**
	* @brief  Interdit les interruptions
  * @note   
	* @param  TIM_TypeDef Timer : indique le timer  utiliser par le chronomtre, TIM1, TIM2, TIM3 ou TIM4
  * @retval None
  */
void MyTimer_IT_Disable(TIM_TypeDef * Timer);

#endif
